unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    W_Edit: TLabeledEdit;
    h_Edit: TLabeledEdit;
    S_Edit: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Button1: TButton;
    CheckBox1: TCheckBox;
    Series3: TLineSeries;
    Series4: TPointSeries;
    R_Edit: TLabeledEdit;
    J_Edit: TLabeledEdit;
    Series5: TPointSeries;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    function datainput: boolean;
    procedure Drawing;
    function f(Ct, S, sL2mh2: double): double;
    function dfdc(Ct, S: double): double;
    function inversed(S, sL2mh2: double): double;
    function inverse_newton(S, sL2mh2: double): double;
    function solve_a(S, h, L: double): double;
    function calc_C: double;
    function calc_C_Def(Cs: double): double;
    function cubic_equation_length: double;
    function calc_arc(a1, b1, c1: double): double;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses
  system.Math;

var
  S : double;     // x m
  R : double;     // ԓ_
  h : double;     // ፷ m
  j : double;     // ԓ_
  W : double;     // d kgw/m
  T : double;     //  kgf
  C : double;     // Jei[
  d : double;     // ox   m
  m : double;     // ő傽݈ʒu m
  dm :double;     // ő傽݈ʒu ox  m
  x : double;     // Βoxn_܂ł̋ m
  L : double;     // 

// ͏
function TForm1.datainput: boolean;
var
  ch: integer;
begin
  result := false;
  val(R_edit.Text, R, ch);
  if (ch <> 0) or (R <= 0) then begin
    application.MessageBox('ԓ_ɊԈႢ܂B','',0);
    exit;
  end;
  val(j_edit.Text, j, ch);
  if (ch <> 0) then begin
    application.MessageBox('ԓ_ɊԈႢ܂B','',0);
    exit;
  end;
  val(S_edit.Text, S, ch);
  if (ch <> 0) or (S <= 0) then begin
    application.MessageBox('xԂɊԈႢ܂B','',0);
    exit;
  end;
  val(h_edit.Text, h, ch);
  if ch <> 0 then begin
    application.MessageBox('x_ɊԈႢ܂B','',0);
    exit;
  end;
  if h / S * R <= j then begin
    application.MessageBox('ԓ_̍܂B','',0);
    exit;
  end;
  if (R >= S) or (R <= 0) then begin
    application.MessageBox('ԓ_̈ʒuxԂ̊OłB','',0);
    exit;
  end;
  val(W_edit.Text, W, ch);
  if (ch <> 0) or (W <= 0) then begin
    application.MessageBox('dɊԈႢ܂B','',0);
    exit;
  end;
  result := true;
end;

// }
// Ⴂ̎xʒu
procedure TForm1.Drawing;
const
  K = 500;
var
  xn  : double;
  x, dx : double;
  y   : double;
  i   : integer;
begin
  dx := S / K;
  // }
  for i := 0 to K do begin
    xn := i * dx;                     // vZʒu
    x := abs(xn - m);                 // őo݈ʒű
    y := C * (cosh(x / C) - 1) - dm;  //  Ⴂ̎xʒuƂČvZ
    Series1.AddXY(xn, y);
  end;
  // Βo݈ʒuʉߐڐ
  Series3.AddXY(0, 0 - d);            // Βo݈ʒuʉߌXΐ Ⴂ
  Series3.AddXY(S, h - d);            // Βo݈ʒuʉߌXΐ 
  // xʒu@Βoxn_@ە\
  Series4.AddXY(0, 0);                // Ⴂ̎xʒu
  Series4.AddXY(R, j);
  Series4.AddXY(S, h);                // ̎xʒu
  x := m + C * arcsinh(h / S);        // Βoxn_ x
  y := h / S * x - d;                 // ΒoxyW
  Series5.AddXY(x, y);                // Βoxxy
end;

// --------- Jei[vZ j[g@ -----------------------

// 덷vZ 2.0 * Ct * sinh(S / (Ct * 2.0)) = sqrt(L^2-h^2)
function TForm1.f(Ct, S, sL2mh2: double): double;
begin
  result := 2.0 * Ct * sinh(S / (2.0 * Ct)) + sL2mh2;
end;

// vZ /Ct
function TForm1.dfdc(Ct, S: double): double;
begin
  result := 2.0 * sinh(S / (2.0 * Ct)) - S * cosh(S / (2.0 * Ct)) / Ct;
end;

// Jei[ߎlvZ
function TForm1.inversed(S, sL2mh2: double): double;
var
  a0, b0, c0: double;
begin
  a0 := sL2mh2 + S;
  b0 := power(S, 3) / 24;
  c0 := power(S, 5) / 1920;
  result := sqrt((-b0 - sqrt(b0 * b0 - 4 * a0 * c0)) / 2 / a0);
end;

// Jei[vZ
function TForm1.inverse_newton(S, sL2mh2: double): double;
const
  Kp  = 1000;
var
  Ct      : double;
  fvalue  : double;
  eps     : double;
  i, n    : integer;
begin
  eps := 1.0E-15 * L;                                     // l
  Ct := inversed(S, sL2mh2);                              // Jei[ߎlvZ
  fvalue := f(Ct, S, sL2mh2);                             // 덷vZ
  n := 0;
  for i := 0 to Kp do begin
    Ct := Ct - fvalue / dfdc(Ct, S);                      // j[g@QvZ
    fvalue := f(Ct, S, sL2mh2);                           // 덷vZ
    inc(n);                                               // JE^[CNg
    if abs(fvalue) < eps then break;                      // 
  end;
  memo1.Lines.Add('Jei[lLoop@@@' + intTostr(n));
  memo1.Lines.Add('b Cl @' + floatTostr(abs(fvalue)));
  if n > kp then begin
    memo1.Lines.Add('Jei[[v܂B');
    memo1.Lines.Add('̒ɋ߂邩܂B');
    Ct := 0;
  end;
  if Ct < 0 then begin
    memo1.Lines.Add('̒ɋ߂܂B');
  end;
  result := Ct;
end;

// j[g@vZX^[g
function TForm1.solve_a(S, h, L: double): double;
begin
  result := inverse_newton(S, -sqrt(L * L - h * h));
end;

//--------------------------------------------------------------

// |`vZ
// EƍɕČvZ
function TForm1.calc_arc(a1, b1, c1: double): double;
var
  L0, L1, L2 : double;
  s1, s2    : double;
  a3, b3    : double;
  a4, b4    : double;
  xc0, yc0  : double;
begin
  xc0 := -b1 / a1 / 2;                               //  ϋȓ_X  Sʒu
  yc0 := xc0 * xc0 * a1 + xc0 * b1 + c1;             //        ϋȓ_y  Sʒu
  b3 := abs(0 - xc0) * 2;
  a3 := abs(0 - yc0);                               // x1̍
  if a3 <> 0 then begin
    s1 := sqrt(b3 * b3 + 16 * a3 * a3);
    L1 := s1 / 2 + b3 * b3 / 8 / a3 * ln((4 * a3 + s1) / b3);
  end
  else L1 := 0;
  b4 := abs(S - xc0) * 2;
  a4 := abs(h - yc0);                              // x2̍
  if a4 <> 0 then begin
    s2 := sqrt(b4 * b4 + 16 * a4 * a4);
    L2 := s2 / 2 + b4 * b4 / 8 / a4 * ln((4 * a4 + s2) / b4);
  end
  else L2 := 0;
  if (0 - xc0) * (S - xc0) > 0 then L0 := abs(L2 - L1) / 2
                               else L0 := (L1 + L2) / 2;
  memo1.Lines.Add('ߎl kf= ' + floatTostr(L0));
  result := L0;
end;

// O_񎟊֐ϊƒvZ
// ax^2 + bx + c = 0
function TForm1.cubic_equation_length: double;
var
  x1, y1  : double;
  x2, y2  : double;
  x3, y3  : double;
  a, b, c : double;
begin
  x1 := 0;
  y1 := 0;
  x2 := R;
  y2 := j;
  x3 := S;
  y3 := h;
  a := ((y1-y2)*(x1-x3)-(y1-y3)*(x1-x2))/((x1-x2)*(x1-x3)*(x2-x3));   // ax^2
  b := (y1-y2)/(x1-x2)-a*(x1+x2);                                     // bx
  c := y1-a*x1*x1-b*x1;                                               // c
  result := calc_arc(a, b, c);      // O_ԒvZ
end;

// Jei[vZ
function TForm1.calc_C: double;
var
  Lc    : double;
  L0, L1: double;
begin
  L0 := sqrt(R * R + j * j);                          // Ԉʒu
  L1 := sqrt((S - R) * (S - R) + (h - j) * (h - j));  // ԈʒuƎxʒu
  Lc := sqrt(S * S + h * h);                          // xԋ
  L := L0 + L1;                                       // Ō񂾏ꍇ̋
  if (L - Lc) < 1.0E-8 * L then begin
    result := 0;                                      // ̍0
    memo1.Lines.Add('̒ɋ߂܂B');
  end
  else begin
    L := cubic_equation_length;                       // 񎟋ȐɂߎvZ
    result := solve_a(S, h, L);                       // Jei[l
  end;
end;

// Ԏwʒuւ̃Jei[vZ
function TForm1.calc_C_Def(Cs: double): double;
var
  df, dc: double;
  dh : double;
  Rh : double;
  Rm : double;
  Rx : double;
  Sm, S2: Double;
  CsB   : Double;
  DCF   : boolean;
  n  : integer;
begin
  memo1.Lines.Add('J^i[l @' + floatTostr(Cs));
  application.ProcessMessages;
  df := 1.0E-15 * L;                   // l
  S2 := S / 2;
  m := S2 - Cs * arcsinh(h / (2 * Cs * sinh(S2 / Cs)));    // ԒႢʒu
  Sm := abs(m);
  Rm := Cs * cosh(Sm / Cs);             // ԒႢʒu̍vZ
  Rx := abs(R - m);                     // ԒႢʒű
  Rh := Cs * cosh(Rx / Cs) - Rm;        //  Ⴂ̎xʒuƂČvZ
  dc := Cs / 125;                       // Jei[␳ll
  DCF := True;
  if j > Rh then DCF := False;          // ԓ_w荂ႩFalse
  n := 0;                               // JE^[NA
  repeat
    CsB := Cs;                          // Jei[obNAbv
    m := S2 - Cs * arcsinh(h / (2 * Cs * sinh(S2 / Cs)));    // ԒႢʒu
    Sm := abs(m);
    Rm := Cs * cosh(Sm / Cs);           // ԒႢʒu̍vZ
    Rx := abs(R - m);                   // ԒႢʒű
    Rh := Cs * cosh(Rx / Cs) - Rm;      //  Ⴂ̎xʒuƂČvZ
    dh := Rh - j;                       // wʒu̍̍
    if DCF then begin
      if dh > 0 then Cs := Cs - dc;     // ̈ʒuJei[Z
      if dh < 0 then begin              // ̈ʒuႭȂ
        Cs := Cs + dc;                  // Jei[߂
        dc := dc * 0.2;                 // ␳l51
        Cs := Cs - dc;                  // Jei[V␳lŌZ
      end;
    end
    else
    begin
      if dh < 0 then Cs := Cs + dc;     // ̈ʒuႩJei[Z
      if dh > 0 then begin              // ̈ʒuȂ
        Cs := Cs - dc;                  // Jei[߂
        dc := dc * 0.2;                 // ␳l51
        Cs := Cs + dc;                  // Jei[V␳lŉZ
      end;
    end;
    inc(n);                             // [vJEgCNg
    // l@[v񐔏  Jei[ωȂ 
  until (abs(dh) < df) or (n > 1000) or (Csb = Cs);
  memo1.Lines.Add('J^i[C Loop@@@' + intTostr(n));
  memo1.Lines.Add('b Cl @' + floatTostr(abs(dc)));
  result := Cs;
end;

// vZ̎s
procedure TForm1.Button1Click(Sender: TObject);
var
  s1,Cs  : double;
  lmin, lmax  : double;
  bmin, bmax  : double;
  mg          : double;
begin
  if not datainput then exit;
  button1.Enabled := False;
  application.ProcessMessages;
  memo1.Clear;
  Cs := calc_C;                       // ̃Jei[vZ
  if Cs <= 0 then begin
    button1.Enabled := True;
    exit;
  end;
  C := calc_C_Def(Cs);                // Ԏw荂̃Jei[vZ
  memo1.Lines.Add('Jei[@@ b@' + floatTostr(C));
  T := C * W;
  memo1.Lines.Add(' j  s@' + floatTostr(T));
  m := S / 2 - C * arcsinh(h / (2 * C * sinh(S / 2 / C)));
  memo1.Lines.Add('ԒႢʒu@@' + floatTostr(m));
  s1 := abs(m * 2);
  dm := C * (cosh(s1 / 2 / C) - 1);
  memo1.Lines.Add('ԒႢʒuox @' + floatTostr(dm));
  x := m + C * arcsinh(h / S);
  memo1.Lines.Add('Βoxʒu@@ ' + floatTostr(x));
  d := x / S * h + C * (cosh(m / C) - cosh(arcsinh(h / S)));
  memo1.Lines.Add('Βox @@@' + floatTostr(d));
  L := C * (sinh(m / C) + sinh((S - m) / C));
  memo1.Lines.Add(' @@@k' + floatTostr(L));
  // OtXP[vZ
  if h < 0 then begin
    lmin := h - d;
    lmax := 0;
  end
  else begin
    lmin := -d;
    lmax := h;
  end;
  bmin := 0;
  bmax := S;
  // OtcXP[ݒ
  if bmax > lmax - lmin then begin
    mg := (bmax - (lmax - lmin)) / 2;
    lmax := lmax + mg;
    lmin := lmin - mg;
  end
  else begin
    mg := ((lmax - lmin) - bmax) / 2;
    bmin := bmin - mg;
    bmax := bmax + mg;
  end;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  Series5.Clear;
  application.ProcessMessages;
  if checkbox1.Checked then begin
    Series2.AddXY(bmin, lmax);
    Series2.AddXY(bmin, lmin);
    Series2.AddXY(bmax, lmin);
  end;
  application.ProcessMessages;
  Drawing;
  button1.Enabled := True;
end;

end.
